library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


entity controller is
	port(red_in : in std_logic_vector(6 downto 0);
			yellow_in : in std_logic_vector(6 downto 0);
			green_in : in std_logic_vector(6 downto 0);
			clk_con : in std_logic;
			led1_con: out std_logic_vector(2 downto 0);
			led2_con: out std_logic_vector(2 downto 0);
			seg1_con: out std_logic_vector(6 downto 0):="0000000";
			seg2_con: out std_logic_vector(6 downto 0):="0000000";
			mode_con: out std_logic_vector(1 downto 0):="00";
			d_ready_con : in std_logic);
end controller;

architecture Behavioral of controller is

signal counter : std_logic_vector(6 downto 0):="0000000";
signal halat : std_logic:='0';

signal red_in_d : std_logic_vector(6 downto 0);
signal green_in_d : std_logic_vector(6 downto 0);
signal d_ready_con_d : std_logic;

begin


process(clk_con,d_ready_con)
begin
d_ready_con_d <= d_ready_con;

if d_ready_con_d='0' and d_ready_con='1' then
	counter <= "0000000";
		red_in_d <= red_in;
		green_in_d <= green_in;

elsif (rising_edge(clk_con)) then
	counter <= counter +1;
	red_in_d <= red_in_d -1;
	green_in_d <= green_in_d-1;
	

	if counter <= green_in then
	
		if halat = '0' then
			led1_con<="100";
			led2_con<="001";
			seg1_con<=red_in_d;
			seg2_con<=green_in_d;
			mode_con <="11" ;
		else
			led2_con<="100";
			led1_con<="001";
			seg2_con<=red_in_d;
			seg1_con<=green_in_d;
			mode_con <="11" ;
		end if;
		
	elsif counter <= red_in-1 then
	
		if halat = '0' then
			led1_con<="100";
			led2_con<="010";
			seg1_con<=red_in_d;
			mode_con <="10" ;
		else
			led2_con<="100";
			led1_con<="010";
			seg2_con<=red_in_d;
			mode_con <="01" ;
		end if;
		
	elsif counter = red_in then
	
		if halat = '0' then
			led1_con<="100";
			led2_con<="010";
			seg1_con<=red_in_d;
			mode_con <="10" ;
			halat <= not(halat);
			counter <= "0000000";
			red_in_d <= red_in;
			green_in_d <= green_in;
		else
			led2_con<="100";
			led1_con<="010";
			seg2_con<=red_in_d;
			mode_con <="01" ;
			halat <= not(halat);
			counter <= "0000000";
			red_in_d <= red_in;
			green_in_d <= green_in;
		end if;
	end if;	
end if;

end process;

end Behavioral;
