library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;


entity segment is
	port(in1 : in std_logic_vector(6 downto 0);
			in2 : in std_logic_vector(6 downto 0);
			mode : in std_logic_vector(1 downto 0);
			clk : in std_logic;
			output : out std_logic_vector(7 downto 0);
			com : out std_logic_vector(3 downto 0));
end segment;

architecture Behavioral of segment is 

signal L_in1 : std_logic_vector(3 downto 0):="0000";
signal B_in1 : std_logic_vector(3 downto 0):="0000";

signal L_in2 : std_logic_vector(3 downto 0):="0000";
signal B_in2 : std_logic_vector(3 downto 0):="0000";

signal count : std_logic_vector(1 downto 0):="00";

begin

process(clk)

variable LL_in1 : std_logic_vector(6 downto 0):="0000000";
variable LL_in2 : std_logic_vector(6 downto 0):="0000000";

begin
	if (rising_edge(clk)) then
		if in1>="1011010" then      -- vorodi 1 be do seven segment 9 taei
			B_in1<="1001";
			LL_in1 := in1-"1011010";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="1010000" then
			B_in1<="1000";
			LL_in1 := in1-"1010000";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="1000110" then
			B_in1<="0111";
			LL_in1 := in1-"1000110";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0111100" then
			B_in1<="0110";
			LL_in1 := in1-"0111100";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0110010" then
			B_in1<="0101";
			LL_in1 := in1-"0110010";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0101000" then
			B_in1<="0100";
			LL_in1 := in1-"0101000";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0011110" then
			B_in1<="0011";
			LL_in1 := in1-"0011110";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0010100" then
			B_in1<="0010";
			LL_in1 := in1-"0010100";
			L_in1<= LL_in1(3 downto 0);
		elsif in1>="0001010" then
			B_in1<="0001";
			LL_in1 := in1-"0001010";
			L_in1<= LL_in1(3 downto 0);
		else
			B_in1<="0000";
			L_in1<= in1(3 downto 0);
		end if;
		
		
		if in2>="1011010" then      -- vorodi 2 be do seven segment 9 taei
			B_in2<="1001";
			LL_in2 := in2-"1011010";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="1010000" then
			B_in2<="1000";
			LL_in2 := in2-"1010000";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="1000110" then
			B_in2<="0111";
			LL_in2 := in2-"1000110";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0111100" then
			B_in2<="0110";
			LL_in2 := in2-"0111100";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0110010" then
			B_in2<="0101";
			LL_in2 := in2-"0110010";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0101000" then
			B_in2<="0100";
			LL_in2 := in2-"0101000";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0011110" then
			B_in2<="0011";
			LL_in2 := in2-"0011110";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0010100" then
			B_in2<="0010";
			LL_in2 := in2-"0010100";
			L_in2<= LL_in2(3 downto 0);
		elsif in2>="0001010" then
			B_in2<="0001";
			LL_in2 := in2-"0001010";
			L_in2<= LL_in2(3 downto 0);
		else
			B_in2<="0000";
			L_in2<= in2(3 downto 0);
		end if;

	-- namayesh

		count <= count+1;
		if count = "00" then
			com <="0001";
			if mode(0)='0' then
				output<="10111111";
			else
				case L_in1 is
					 when "0000" => output<="11000000";
					 when "0001" => output<="11111001";
					 when "0010" => output<="10100100";
					 when "0011" => output<="10110000";
					 when "0100" => output<="10011001";
					 when "0101" => output<="10010010";
					 when "0110" => output<="10000010";
					 when "0111" => output<="11111000";
					 when "1000" => output<="10000000";
					 when "1001" => output<="10010000";
					 when others => output<="00000000";
				end case;
			end if;
		end if;
		
		if count = "01" then
			com <="0010";
			if mode(0)='0' then
				output<="10111111";
			else
				case B_in1 is
					 when "0000" => output<="11000000";
					 when "0001" => output<="11111001";
					 when "0010" => output<="10100100";
					 when "0011" => output<="10110000";
					 when "0100" => output<="10011001";
					 when "0101" => output<="10010010";
					 when "0110" => output<="10000010";
					 when "0111" => output<="11111000";
					 when "1000" => output<="10000000";
					 when "1001" => output<="10010000";
					 when others => output<="00000000";
				end case;
			end if;
		end if;
		
		if count = "10" then
			com <="0100";
			if mode(1)='0' then
				output<="10111111";
			else
				case L_in2 is
					 when "0000" => output<="11000000";
					 when "0001" => output<="11111001";
					 when "0010" => output<="10100100";
					 when "0011" => output<="10110000";
					 when "0100" => output<="10011001";
					 when "0101" => output<="10010010";
					 when "0110" => output<="10000010";
					 when "0111" => output<="11111000";
					 when "1000" => output<="10000000";
					 when "1001" => output<="10010000";
					 when others => output<="00000000";
				end case;
			end if;
		end if;
		
		if count = "11" then
			com <="1000";
			if mode(1)='0' then
				output<="10111111";
			else
				case B_in2 is
					 when "0000" => output<="11000000";
					 when "0001" => output<="11111001";
					 when "0010" => output<="10100100";
					 when "0011" => output<="10110000";
					 when "0100" => output<="10011001";
					 when "0101" => output<="10010010";
					 when "0110" => output<="10000010";
					 when "0111" => output<="11111000";
					 when "1000" => output<="10000000";
					 when "1001" => output<="10010000";
					 when others => output<="00000000";
				end case;
			end if;
		end if;
	end if;
end process;


end Behavioral;